--------------------------------------------------------------------------
-- LAB 03: example - generic counter 
-- Prescaler
--------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity prescaler is
    generic (width : integer := 27); -- the width of a prescaler counter
    port (
        clock:         in  std_logic;
        reset:         in  std_logic;
        limit:         in  integer;
        clock_enable : out std_logic);
end prescaler;

architecture Behavioral of prescaler is
    signal value: unsigned(width-1 downto 0);
begin
    process (clock)
    begin
        if rising_edge(clock) then
            if reset = '1' then
                value <= (others => '0');
                clock_enable <= '0';
            else
                if value >= limit then
                    value <= (others => '0');
                    clock_enable <= '1';
                else
                    value <= value + 1;
                    clock_enable <= '0';
                end if;
            end if;
        end if;
    end process;
end Behavioral;
